Index: issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h	(revision 23389)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h	(revision 23394)
@@ -1,5 +1,5 @@
 /*!\file:  SurfaceMassBalancex.h
  * \brief header file for SMB
- */ 
+ */
 
 #ifndef _SurfaceMassBalancex_H
@@ -16,11 +16,12 @@
 void Delta18opdParameterizationx(FemModel* femmodel);
 void PositiveDegreeDayx(FemModel* femmodel);
+void PositiveDegreeDaySicopolisx(FemModel* femmodel);
 void SmbHenningx(FemModel* femmodel);
 void SmbComponentsx(FemModel* femmodel);
-void SmbMeltComponentsx(FemModel* femmodel); 
-
+void SmbMeltComponentsx(FemModel* femmodel);
+void SmbGradientsComponentsx(FemModel* femmodel);
 /*GEMB: */
 void       Gembx(FemModel* femmodel);
-void       GembgridInitialize(IssmDouble** pdz, int* psize, IssmDouble zTop, IssmDouble dzTop, IssmDouble zMax, IssmDouble zY); 
+void       GembgridInitialize(IssmDouble** pdz, int* psize, IssmDouble zTop, IssmDouble dzTop, IssmDouble zMax, IssmDouble zY);
 IssmDouble Marbouty(IssmDouble T, IssmDouble d, IssmDouble dT);
 void grainGrowth(IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, IssmDouble* T,IssmDouble* dz,IssmDouble* d, IssmDouble* W,IssmDouble smb_dt,int m,int aIdx, int sid);
@@ -28,5 +29,5 @@
 void shortwave(IssmDouble** pswf, int swIdx, int aIdx, IssmDouble dsw, IssmDouble as, IssmDouble* d, IssmDouble* dz, IssmDouble* re, IssmDouble dIce, int m, int sid);
 void thermo(IssmDouble* pEC, IssmDouble** T, IssmDouble* dz, IssmDouble* d, IssmDouble* swf, IssmDouble dlw, IssmDouble Ta, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble teValue, IssmDouble Ws, IssmDouble dt0, int m, IssmDouble Vz, IssmDouble Tz, IssmDouble thermo_scaling, IssmDouble dIce, int sid);
-void accumulation(IssmDouble** pT, IssmDouble** pdz, IssmDouble** pd, IssmDouble** pW, IssmDouble** pa, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pm, int aIdx,IssmDouble Ta, IssmDouble P, IssmDouble dzMin, IssmDouble aSnow, IssmDouble dIce, int sid); 
+void accumulation(IssmDouble** pT, IssmDouble** pdz, IssmDouble** pd, IssmDouble** pW, IssmDouble** pa, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pm, int aIdx,IssmDouble Ta, IssmDouble P, IssmDouble dzMin, IssmDouble aSnow, IssmDouble dIce, int sid);
 void melt(IssmDouble* pM, IssmDouble* pR, IssmDouble* pmAdd, IssmDouble* pdz_add, IssmDouble** pT, IssmDouble** pd, IssmDouble** pdz, IssmDouble** pW, IssmDouble** pa, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pn, IssmDouble dzMin, IssmDouble zMax, IssmDouble zMin, IssmDouble zTop, IssmDouble dIce, int sid);
 void densification(IssmDouble** pd,IssmDouble** pdz, IssmDouble* T, IssmDouble* re, int denIdx, IssmDouble C, IssmDouble dt, IssmDouble Tmean, IssmDouble dIce, int m, int sid);
Index: issm/trunk/src/c/shared/Elements/PddSurfaceMassBalanceSicopolis.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/PddSurfaceMassBalanceSicopolis.cpp	(revision 23394)
+++ issm/trunk/src/c/shared/Elements/PddSurfaceMassBalanceSicopolis.cpp	(revision 23394)
@@ -0,0 +1,137 @@
+/* file:  PddSurfaceMassBlanceSicopolis.cpp
+   Calculating the surface mass balance using the adapted PDD routine from SICOPOLIS.
+ */
+
+#include "./elements.h"
+#include "../Numerics/numerics.h"
+#include "../Exceptions/exceptions.h"
+
+IssmDouble PddSurfaceMassBalanceSicopolis(IssmDouble* monthlytemperatures, IssmDouble* monthlyprec,
+				 IssmDouble* melt, IssmDouble* accu, IssmDouble* melt_star, IssmDouble* t_ampl, IssmDouble* p_ampl,
+				 IssmDouble yts, IssmDouble s, IssmDouble desfac,
+				 IssmDouble s0t, IssmDouble s0p, IssmDouble rlaps,
+				 IssmDouble rho_water,IssmDouble rho_ice){
+
+  int			imonth;				// month counter
+  IssmDouble B;					// output: surface mass balance (m/a IE), melt+accumulation
+  IssmDouble frac_solid, snowfall, rainfall, runoff; 
+  IssmDouble saccu;				// yearly surface accumulation (m/a IE)
+  IssmDouble smelt;				// yearly melt (m/a IE)
+  IssmDouble smelt_star;		// yearly ...
+  IssmDouble precip;				// total precipitation during 1 year
+  IssmDouble sconv;				//rhow_rain/rhoi / 12 months
+  IssmDouble st;					// elevation between altitude of the temp record and current altitude
+  IssmDouble sp;					// elevation between altitude of the prec record and current altitude
+  IssmDouble q;					// q is desert/elev. fact
+  IssmDouble pdd;					// pdd factor (a * degC)
+  IssmDouble tstar;				// monthly temp. after lapse rate correction (degC)
+  IssmDouble precip_star;		// monthly precip after correction (m/a IE)
+  IssmDouble beta1 = 2.73;		// 3 mm IE/(d*deg C),  ablation factor for snow per positive degree day.
+  IssmDouble beta2 = 7.28;		// 8 mm IE/(d*deg C),  ablation factor for ice per pdd (Braithwaite 1995 from tarasov 2002).
+  IssmDouble Pmax = 0.6;
+  IssmDouble inv_twelve=1./12.; 
+  
+  sconv=(rho_water/rho_ice);		//rhow_rain/rhoi
+
+  /* FIXME betas shoud be user input */
+  beta1=beta1*(0.001*365)*sconv; // (mm WE)/(d*deg C) --> (m IE)/(a*deg C)
+  beta2=beta2*(0.001*365)*sconv; // (mm WE)/(d*deg C) --> (m IE)/(a*deg C)
+
+  /* initalize fields */
+  precip=0.0;
+  tstar=0.0;
+  snowfall=0.0;
+  pdd=0.0;
+  /* seasonal loop */
+  for(imonth=0;imonth<12;imonth++){
+
+    /********* Surface temperature correction *******/    
+    st=(s-s0t)/1000.;
+
+    // FIXME rlaps ??
+	 rlaps=-6.309e-03+(-5.426e-03-(-6.309e-03))*sin((imonth+1-4)*PI/6.0)*1000.0;
+    monthlytemperatures[imonth]=monthlytemperatures[imonth]-rlaps*st;//*max(st,1e-3);
+    tstar=monthlytemperatures[imonth]+t_ampl[0];
+
+    /********* Precipitation correction *************/
+    /* Ref: Vizcaino et al 2010; DOI 10.1007/s00382-009-0591-y */
+    if(s0p<2000.0)
+      q=exp(desfac*(max(s,2000.0)-2000.0));
+	 else
+      q=exp(desfac*(max(s,2000.0)-s0p));
+
+    precip_star=q*monthlyprec[imonth]*sconv*p_ampl[0]*yts; // convert precip from m/s -> m/a
+    precip=precip+precip_star*inv_twelve;
+
+    /********* compute PDD **************************/
+    /* Ref: Calov & Greve 2005 Journal of Glaciology, Vol. 51, No. 172, 2005, Correspondence */
+	 IssmDouble s_stat=5.0;
+    IssmDouble inv_sqrt2pi =1.0/sqrt(2.0*PI);
+    IssmDouble inv_s_stat  =1.0/s_stat;
+    IssmDouble inv_sqrt2   =1.0/sqrt(2.0);
+
+	 #if !defined(_HAVE_ADOLC_)
+    pdd=pdd+(s_stat*inv_sqrt2pi*exp(-0.5*pow(tstar*inv_s_stat,2))
+				 +0.5*tstar*erfc(-tstar*inv_s_stat*inv_sqrt2))*inv_twelve;
+	 #else
+	 _error_("Cannot differentiate erfc, talk to ADOLC folks (http://functions.wolfram.com/GammaBetaErf/Erfc/20/01/)");
+	 #endif
+
+	 /*Partition of precip in solid and liquid parts, Bales et al. (2009) */
+	 IssmDouble temp_rain=7.2;		// Threshold monthly mean temperature for
+											// precipitation = 101% rain, in deg C
+	 IssmDouble temp_snow=-11.6;  // Threshold monthly mean temperature for
+											// precipitation = 100% snow, in deg C
+
+	 IssmDouble coeff1=5.4714e-01;	// Coefficients
+	 IssmDouble coeff2=-9.1603e-02;	// of
+	 IssmDouble coeff3=-3.314e-03;	// the
+	 IssmDouble coeff4= 4.66e-04;		// fifth-order
+	 IssmDouble coeff5=3.8e-05;		// polynomial
+	 IssmDouble coeff6=6.0e-07;		// fit
+   
+	 if(tstar>=temp_rain)
+	  frac_solid = 0.0;
+	 else if(tstar<=temp_snow)
+	  frac_solid = 1.0;
+	 else{ 
+		 frac_solid=coeff1+tstar*(coeff2
+					 +tstar*(coeff3+tstar*(coeff4+tstar*(coeff5+tstar*coeff6))));
+	 }
+	 
+	 snowfall=snowfall+precip_star*frac_solid*inv_twelve;
+  } 
+  /* end of seasonal loop */ 
+
+  rainfall=precip-snowfall;
+  if(snowfall<0.0) snowfall=0.0;   // correction of
+  if(rainfall<0.0) rainfall=0.0;   // negative values
+   
+  if(rainfall<=(Pmax*snowfall)){
+	  if((rainfall+beta1*pdd)<=(Pmax*snowfall)) {
+		  smelt_star = rainfall+beta1*pdd;
+		  smelt      = 0.0;
+		  runoff     = smelt;
+	  }
+	  else{
+		  smelt_star = Pmax*snowfall;
+		  smelt      = beta2*(pdd-(smelt_star-rainfall)/beta1);
+		  runoff     = smelt;
+	  }
+  } 
+  else{
+	  smelt_star = Pmax*snowfall;
+	  smelt      = beta2*pdd;
+	  runoff     = smelt+rainfall-Pmax*snowfall;
+  }
+   
+  saccu = precip;	
+
+  /* asign output*/
+  melt[0]=runoff/yts;
+  accu[0]=saccu/yts;
+  melt_star[0]=smelt_star/yts;
+  B=(saccu-runoff)/yts;
+
+  return B;
+}
Index: issm/trunk/src/c/shared/Elements/PrintArrays.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/PrintArrays.cpp	(revision 23389)
+++ issm/trunk/src/c/shared/Elements/PrintArrays.cpp	(revision 23394)
@@ -12,5 +12,5 @@
 	_printf_("\n");
 }
-#ifdef _HAVE_ADOLC_
+#ifdef _HAVE_AD_
 void printarray(IssmDouble* array,int lines,int cols){
 	_printf_("\n");
Index: issm/trunk/src/c/shared/Elements/elements.h
===================================================================
--- issm/trunk/src/c/shared/Elements/elements.h	(revision 23389)
+++ issm/trunk/src/c/shared/Elements/elements.h	(revision 23394)
@@ -24,4 +24,8 @@
 				 IssmDouble TdiffTime,IssmDouble sealevTime,IssmDouble pddsnowfac,IssmDouble pddicefac,
 				 IssmDouble rho_water, IssmDouble rho_ice);
+IssmDouble PddSurfaceMassBalanceSicopolis(IssmDouble* monthlytemperatures,  IssmDouble* monthlyprec,
+				 IssmDouble* melt, IssmDouble* accu, IssmDouble* melt_star, IssmDouble* t_ampl, IssmDouble* p_ampl,
+				 IssmDouble yts, IssmDouble s, IssmDouble desfac,IssmDouble s0t,
+				 IssmDouble s0p, IssmDouble rlaps, IssmDouble rho_water, IssmDouble rho_ice);
 void ComputeDelta18oTemperaturePrecipitation(IssmDouble Delta18oSurfacePresent, IssmDouble Delta18oSurfaceLgm, IssmDouble Delta18oSurfaceTime,
 					     IssmDouble Delta18oPresent, IssmDouble Delta18oLgm, IssmDouble Delta18oTime,
@@ -42,5 +46,5 @@
 /*Print arrays*/
 void printarray(IssmPDouble* array,int lines,int cols=1);
-#if _HAVE_ADOLC_  && !defined(_WRAPPERS_)
+#if _HAVE_AD_  && !defined(_WRAPPERS_)
 void printarray(IssmDouble* array,int lines,int cols=1);
 #endif
Index: issm/trunk/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk/src/c/shared/Enum/EnumDefinitions.h	(revision 23389)
+++ issm/trunk/src/c/shared/Enum/EnumDefinitions.h	(revision 23394)
@@ -53,4 +53,5 @@
 	AutodiffNumIndependentsEnum,
 	AutodiffObufsizeEnum,
+	AutodiffTapeAllocEnum,
 	AutodiffTbufsizeEnum,
 	AutodiffXpEnum,
@@ -272,4 +273,7 @@
 	SettingsSolverResidueThresholdEnum,
 	SettingsWaitonlockEnum,
+	SmbAccualtiEnum,
+	SmbAccugradEnum,
+	SmbAccurefEnum,
 	SmbAdThreshEnum,
 	SmbAIceEnum,
@@ -290,4 +294,5 @@
 	SmbIsdensificationEnum,
 	SmbIsgraingrowthEnum,
+	SmbIsfirnwarmingEnum,
 	SmbIsmeltEnum,
 	SmbIsmungsmEnum,
@@ -302,4 +307,7 @@
 	SmbPfacEnum,
 	SmbRequestedOutputsEnum,
+	SmbRunoffaltiEnum,
+	SmbRunoffgradEnum,
+	SmbRunoffrefEnum,
 	SmbSealevEnum,
 	SmbSwIdxEnum,
@@ -526,7 +534,7 @@
 	SealevelNEsaRateEnum,
 	SealevelRSLRateEnum,
-	SealevelUEsaEnum, 
+	SealevelUEsaEnum,
 	SealevelRSLEustaticRateEnum,
-	SealevelNEsaEnum, 
+	SealevelNEsaEnum,
 	SealevelUGiaEnum,
 	SealevelNGiaEnum,
@@ -577,4 +585,5 @@
 	SmbPEnum,
 	SmbPrecipitationEnum,
+	SmbPrecipitationsAnomalyEnum,
 	SmbPrecipitationsLgmEnum,
 	SmbPrecipitationsPresentdayEnum,
@@ -588,5 +597,7 @@
 	SmbSizeiniEnum,
 	SmbSmbrefEnum,
+	SmbSmbCorrEnum,
 	SmbTaEnum,
+	SmbTemperaturesAnomalyEnum,
 	SmbTemperaturesLgmEnum,
 	SmbTemperaturesPresentdayEnum,
@@ -1095,4 +1106,6 @@
 	SMBmeltcomponentsEnum,
 	SMBpddEnum,
+	SMBpddSicopolisEnum,
+	SMBgradientscomponentsEnum,
 	SmbRlapsEnum,
 	SmbRlapslgmEnum,
Index: issm/trunk/src/c/shared/Enum/EnumToStringx.cpp
===================================================================
--- issm/trunk/src/c/shared/Enum/EnumToStringx.cpp	(revision 23389)
+++ issm/trunk/src/c/shared/Enum/EnumToStringx.cpp	(revision 23394)
@@ -61,4 +61,5 @@
 		case AutodiffNumIndependentsEnum : return "AutodiffNumIndependents";
 		case AutodiffObufsizeEnum : return "AutodiffObufsize";
+		case AutodiffTapeAllocEnum : return "AutodiffTapeAlloc";
 		case AutodiffTbufsizeEnum : return "AutodiffTbufsize";
 		case AutodiffXpEnum : return "AutodiffXp";
@@ -280,4 +281,7 @@
 		case SettingsSolverResidueThresholdEnum : return "SettingsSolverResidueThreshold";
 		case SettingsWaitonlockEnum : return "SettingsWaitonlock";
+		case SmbAccualtiEnum : return "SmbAccualti";
+		case SmbAccugradEnum : return "SmbAccugrad";
+		case SmbAccurefEnum : return "SmbAccuref";
 		case SmbAdThreshEnum : return "SmbAdThresh";
 		case SmbAIceEnum : return "SmbAIce";
@@ -298,4 +302,5 @@
 		case SmbIsdensificationEnum : return "SmbIsdensification";
 		case SmbIsgraingrowthEnum : return "SmbIsgraingrowth";
+		case SmbIsfirnwarmingEnum : return "SmbIsfirnwarming";
 		case SmbIsmeltEnum : return "SmbIsmelt";
 		case SmbIsmungsmEnum : return "SmbIsmungsm";
@@ -310,4 +315,7 @@
 		case SmbPfacEnum : return "SmbPfac";
 		case SmbRequestedOutputsEnum : return "SmbRequestedOutputs";
+		case SmbRunoffaltiEnum : return "SmbRunoffalti";
+		case SmbRunoffgradEnum : return "SmbRunoffgrad";
+		case SmbRunoffrefEnum : return "SmbRunoffref";
 		case SmbSealevEnum : return "SmbSealev";
 		case SmbSwIdxEnum : return "SmbSwIdx";
@@ -583,4 +591,5 @@
 		case SmbPEnum : return "SmbP";
 		case SmbPrecipitationEnum : return "SmbPrecipitation";
+		case SmbPrecipitationsAnomalyEnum : return "SmbPrecipitationsAnomaly";
 		case SmbPrecipitationsLgmEnum : return "SmbPrecipitationsLgm";
 		case SmbPrecipitationsPresentdayEnum : return "SmbPrecipitationsPresentday";
@@ -594,5 +603,7 @@
 		case SmbSizeiniEnum : return "SmbSizeini";
 		case SmbSmbrefEnum : return "SmbSmbref";
+		case SmbSmbCorrEnum : return "SmbSmbCorr";
 		case SmbTaEnum : return "SmbTa";
+		case SmbTemperaturesAnomalyEnum : return "SmbTemperaturesAnomaly";
 		case SmbTemperaturesLgmEnum : return "SmbTemperaturesLgm";
 		case SmbTemperaturesPresentdayEnum : return "SmbTemperaturesPresentday";
@@ -1099,4 +1110,6 @@
 		case SMBmeltcomponentsEnum : return "SMBmeltcomponents";
 		case SMBpddEnum : return "SMBpdd";
+		case SMBpddSicopolisEnum : return "SMBpddSicopolis";
+		case SMBgradientscomponentsEnum : return "SMBgradientscomponents";
 		case SmbRlapsEnum : return "SmbRlaps";
 		case SmbRlapslgmEnum : return "SmbRlapslgm";
Index: issm/trunk/src/c/shared/Enum/StringToEnumx.cpp
===================================================================
--- issm/trunk/src/c/shared/Enum/StringToEnumx.cpp	(revision 23389)
+++ issm/trunk/src/c/shared/Enum/StringToEnumx.cpp	(revision 23394)
@@ -61,4 +61,5 @@
 	      else if (strcmp(name,"AutodiffNumIndependents")==0) return AutodiffNumIndependentsEnum;
 	      else if (strcmp(name,"AutodiffObufsize")==0) return AutodiffObufsizeEnum;
+	      else if (strcmp(name,"AutodiffTapeAlloc")==0) return AutodiffTapeAllocEnum;
 	      else if (strcmp(name,"AutodiffTbufsize")==0) return AutodiffTbufsizeEnum;
 	      else if (strcmp(name,"AutodiffXp")==0) return AutodiffXpEnum;
@@ -136,9 +137,9 @@
 	      else if (strcmp(name,"FrictionLaw")==0) return FrictionLawEnum;
 	      else if (strcmp(name,"FrictionPseudoplasticityExponent")==0) return FrictionPseudoplasticityExponentEnum;
-	      else if (strcmp(name,"FrictionThresholdSpeed")==0) return FrictionThresholdSpeedEnum;
          else stage=2;
    }
    if(stage==2){
-	      if (strcmp(name,"FrictionDelta")==0) return FrictionDeltaEnum;
+	      if (strcmp(name,"FrictionThresholdSpeed")==0) return FrictionThresholdSpeedEnum;
+	      else if (strcmp(name,"FrictionDelta")==0) return FrictionDeltaEnum;
 	      else if (strcmp(name,"FrictionVoidRatio")==0) return FrictionVoidRatioEnum;
 	      else if (strcmp(name,"GiaCrossSectionShape")==0) return GiaCrossSectionShapeEnum;
@@ -259,9 +260,9 @@
 	      else if (strcmp(name,"SealevelriseFluidLove")==0) return SealevelriseFluidLoveEnum;
 	      else if (strcmp(name,"SealevelriseGElastic")==0) return SealevelriseGElasticEnum;
-	      else if (strcmp(name,"SealevelriseGeodetic")==0) return SealevelriseGeodeticEnum;
          else stage=3;
    }
    if(stage==3){
-	      if (strcmp(name,"SealevelriseGeodeticRunFrequency")==0) return SealevelriseGeodeticRunFrequencyEnum;
+	      if (strcmp(name,"SealevelriseGeodetic")==0) return SealevelriseGeodeticEnum;
+	      else if (strcmp(name,"SealevelriseGeodeticRunFrequency")==0) return SealevelriseGeodeticRunFrequencyEnum;
 	      else if (strcmp(name,"SealevelriseHElastic")==0) return SealevelriseHElasticEnum;
 	      else if (strcmp(name,"SealevelriseHoriz")==0) return SealevelriseHorizEnum;
@@ -286,4 +287,7 @@
 	      else if (strcmp(name,"SettingsSolverResidueThreshold")==0) return SettingsSolverResidueThresholdEnum;
 	      else if (strcmp(name,"SettingsWaitonlock")==0) return SettingsWaitonlockEnum;
+	      else if (strcmp(name,"SmbAccualti")==0) return SmbAccualtiEnum;
+	      else if (strcmp(name,"SmbAccugrad")==0) return SmbAccugradEnum;
+	      else if (strcmp(name,"SmbAccuref")==0) return SmbAccurefEnum;
 	      else if (strcmp(name,"SmbAdThresh")==0) return SmbAdThreshEnum;
 	      else if (strcmp(name,"SmbAIce")==0) return SmbAIceEnum;
@@ -304,4 +308,5 @@
 	      else if (strcmp(name,"SmbIsdensification")==0) return SmbIsdensificationEnum;
 	      else if (strcmp(name,"SmbIsgraingrowth")==0) return SmbIsgraingrowthEnum;
+	      else if (strcmp(name,"SmbIsfirnwarming")==0) return SmbIsfirnwarmingEnum;
 	      else if (strcmp(name,"SmbIsmelt")==0) return SmbIsmeltEnum;
 	      else if (strcmp(name,"SmbIsmungsm")==0) return SmbIsmungsmEnum;
@@ -316,4 +321,7 @@
 	      else if (strcmp(name,"SmbPfac")==0) return SmbPfacEnum;
 	      else if (strcmp(name,"SmbRequestedOutputs")==0) return SmbRequestedOutputsEnum;
+	      else if (strcmp(name,"SmbRunoffalti")==0) return SmbRunoffaltiEnum;
+	      else if (strcmp(name,"SmbRunoffgrad")==0) return SmbRunoffgradEnum;
+	      else if (strcmp(name,"SmbRunoffref")==0) return SmbRunoffrefEnum;
 	      else if (strcmp(name,"SmbSealev")==0) return SmbSealevEnum;
 	      else if (strcmp(name,"SmbSwIdx")==0) return SmbSwIdxEnum;
@@ -375,5 +383,8 @@
 	      else if (strcmp(name,"TransientIsmovingfront")==0) return TransientIsmovingfrontEnum;
 	      else if (strcmp(name,"TransientIsoceancoupling")==0) return TransientIsoceancouplingEnum;
-	      else if (strcmp(name,"TransientIsslr")==0) return TransientIsslrEnum;
+         else stage=4;
+   }
+   if(stage==4){
+	      if (strcmp(name,"TransientIsslr")==0) return TransientIsslrEnum;
 	      else if (strcmp(name,"TransientIssmb")==0) return TransientIssmbEnum;
 	      else if (strcmp(name,"TransientIsstressbalance")==0) return TransientIsstressbalanceEnum;
@@ -383,8 +394,5 @@
 	      else if (strcmp(name,"Velocity")==0) return VelocityEnum;
 	      else if (strcmp(name,"WorldComm")==0) return WorldCommEnum;
-         else stage=4;
-   }
-   if(stage==4){
-	      if (strcmp(name,"ParametersEND")==0) return ParametersENDEnum;
+	      else if (strcmp(name,"ParametersEND")==0) return ParametersENDEnum;
 	      else if (strcmp(name,"InputsSTART")==0) return InputsSTARTEnum;
 	      else if (strcmp(name,"Adjoint")==0) return AdjointEnum;
@@ -498,5 +506,8 @@
 	      else if (strcmp(name,"Ice")==0) return IceEnum;
 	      else if (strcmp(name,"IceMaskNodeActivation")==0) return IceMaskNodeActivationEnum;
-	      else if (strcmp(name,"Input")==0) return InputEnum;
+         else stage=5;
+   }
+   if(stage==5){
+	      if (strcmp(name,"Input")==0) return InputEnum;
 	      else if (strcmp(name,"InversionCostFunctionsCoefficients")==0) return InversionCostFunctionsCoefficientsEnum;
 	      else if (strcmp(name,"InversionSurfaceObs")==0) return InversionSurfaceObsEnum;
@@ -506,8 +517,5 @@
 	      else if (strcmp(name,"InversionVyObs")==0) return InversionVyObsEnum;
 	      else if (strcmp(name,"LevelsetfunctionSlopeX")==0) return LevelsetfunctionSlopeXEnum;
-         else stage=5;
-   }
-   if(stage==5){
-	      if (strcmp(name,"LevelsetfunctionSlopeY")==0) return LevelsetfunctionSlopeYEnum;
+	      else if (strcmp(name,"LevelsetfunctionSlopeY")==0) return LevelsetfunctionSlopeYEnum;
 	      else if (strcmp(name,"LoadingforceX")==0) return LoadingforceXEnum;
 	      else if (strcmp(name,"LoadingforceY")==0) return LoadingforceYEnum;
@@ -595,4 +603,5 @@
 	      else if (strcmp(name,"SmbP")==0) return SmbPEnum;
 	      else if (strcmp(name,"SmbPrecipitation")==0) return SmbPrecipitationEnum;
+	      else if (strcmp(name,"SmbPrecipitationsAnomaly")==0) return SmbPrecipitationsAnomalyEnum;
 	      else if (strcmp(name,"SmbPrecipitationsLgm")==0) return SmbPrecipitationsLgmEnum;
 	      else if (strcmp(name,"SmbPrecipitationsPresentday")==0) return SmbPrecipitationsPresentdayEnum;
@@ -606,5 +615,7 @@
 	      else if (strcmp(name,"SmbSizeini")==0) return SmbSizeiniEnum;
 	      else if (strcmp(name,"SmbSmbref")==0) return SmbSmbrefEnum;
+	      else if (strcmp(name,"SmbSmbCorr")==0) return SmbSmbCorrEnum;
 	      else if (strcmp(name,"SmbTa")==0) return SmbTaEnum;
+	      else if (strcmp(name,"SmbTemperaturesAnomaly")==0) return SmbTemperaturesAnomalyEnum;
 	      else if (strcmp(name,"SmbTemperaturesLgm")==0) return SmbTemperaturesLgmEnum;
 	      else if (strcmp(name,"SmbTemperaturesPresentday")==0) return SmbTemperaturesPresentdayEnum;
@@ -618,5 +629,8 @@
 	      else if (strcmp(name,"SmbVz")==0) return SmbVzEnum;
 	      else if (strcmp(name,"SmbW")==0) return SmbWEnum;
-	      else if (strcmp(name,"SmbWini")==0) return SmbWiniEnum;
+         else stage=6;
+   }
+   if(stage==6){
+	      if (strcmp(name,"SmbWini")==0) return SmbWiniEnum;
 	      else if (strcmp(name,"SmbZMax")==0) return SmbZMaxEnum;
 	      else if (strcmp(name,"SmbZMin")==0) return SmbZMinEnum;
@@ -629,8 +643,5 @@
 	      else if (strcmp(name,"StrainRatexy")==0) return StrainRatexyEnum;
 	      else if (strcmp(name,"StrainRatexz")==0) return StrainRatexzEnum;
-         else stage=6;
-   }
-   if(stage==6){
-	      if (strcmp(name,"StrainRateyy")==0) return StrainRateyyEnum;
+	      else if (strcmp(name,"StrainRateyy")==0) return StrainRateyyEnum;
 	      else if (strcmp(name,"StrainRateyz")==0) return StrainRateyzEnum;
 	      else if (strcmp(name,"StrainRatezz")==0) return StrainRatezzEnum;
@@ -741,5 +752,8 @@
 	      else if (strcmp(name,"DatasetInput")==0) return DatasetInputEnum;
 	      else if (strcmp(name,"DataSetParam")==0) return DataSetParamEnum;
-	      else if (strcmp(name,"DefaultAnalysis")==0) return DefaultAnalysisEnum;
+         else stage=7;
+   }
+   if(stage==7){
+	      if (strcmp(name,"DefaultAnalysis")==0) return DefaultAnalysisEnum;
 	      else if (strcmp(name,"DefaultCalving")==0) return DefaultCalvingEnum;
 	      else if (strcmp(name,"DegreeOfChannelization")==0) return DegreeOfChannelizationEnum;
@@ -752,8 +766,5 @@
 	      else if (strcmp(name,"Domain3Dsurface")==0) return Domain3DsurfaceEnum;
 	      else if (strcmp(name,"DoubleArrayInput")==0) return DoubleArrayInputEnum;
-         else stage=7;
-   }
-   if(stage==7){
-	      if (strcmp(name,"DoubleExternalResult")==0) return DoubleExternalResultEnum;
+	      else if (strcmp(name,"DoubleExternalResult")==0) return DoubleExternalResultEnum;
 	      else if (strcmp(name,"DoubleInput")==0) return DoubleInputEnum;
 	      else if (strcmp(name,"DoubleMatArrayParam")==0) return DoubleMatArrayParamEnum;
@@ -864,5 +875,8 @@
 	      else if (strcmp(name,"LambdaS")==0) return LambdaSEnum;
 	      else if (strcmp(name,"LATaylorHood")==0) return LATaylorHoodEnum;
-	      else if (strcmp(name,"LevelsetAnalysis")==0) return LevelsetAnalysisEnum;
+         else stage=8;
+   }
+   if(stage==8){
+	      if (strcmp(name,"LevelsetAnalysis")==0) return LevelsetAnalysisEnum;
 	      else if (strcmp(name,"LevelsetfunctionPicard")==0) return LevelsetfunctionPicardEnum;
 	      else if (strcmp(name,"LinearFloatingMeltRate")==0) return LinearFloatingMeltRateEnum;
@@ -875,8 +889,5 @@
 	      else if (strcmp(name,"LoveKernelsImag")==0) return LoveKernelsImagEnum;
 	      else if (strcmp(name,"LoveKernelsReal")==0) return LoveKernelsRealEnum;
-         else stage=8;
-   }
-   if(stage==8){
-	      if (strcmp(name,"LoveKi")==0) return LoveKiEnum;
+	      else if (strcmp(name,"LoveKi")==0) return LoveKiEnum;
 	      else if (strcmp(name,"LoveKr")==0) return LoveKrEnum;
 	      else if (strcmp(name,"LoveLi")==0) return LoveLiEnum;
@@ -987,5 +998,8 @@
 	      else if (strcmp(name,"Outputdefinition37")==0) return Outputdefinition37Enum;
 	      else if (strcmp(name,"Outputdefinition38")==0) return Outputdefinition38Enum;
-	      else if (strcmp(name,"Outputdefinition39")==0) return Outputdefinition39Enum;
+         else stage=9;
+   }
+   if(stage==9){
+	      if (strcmp(name,"Outputdefinition39")==0) return Outputdefinition39Enum;
 	      else if (strcmp(name,"Outputdefinition3")==0) return Outputdefinition3Enum;
 	      else if (strcmp(name,"Outputdefinition40")==0) return Outputdefinition40Enum;
@@ -998,8 +1012,5 @@
 	      else if (strcmp(name,"Outputdefinition47")==0) return Outputdefinition47Enum;
 	      else if (strcmp(name,"Outputdefinition48")==0) return Outputdefinition48Enum;
-         else stage=9;
-   }
-   if(stage==9){
-	      if (strcmp(name,"Outputdefinition49")==0) return Outputdefinition49Enum;
+	      else if (strcmp(name,"Outputdefinition49")==0) return Outputdefinition49Enum;
 	      else if (strcmp(name,"Outputdefinition4")==0) return Outputdefinition4Enum;
 	      else if (strcmp(name,"Outputdefinition50")==0) return Outputdefinition50Enum;
@@ -1110,5 +1121,8 @@
 	      else if (strcmp(name,"SMBcomponents")==0) return SMBcomponentsEnum;
 	      else if (strcmp(name,"SMBd18opdd")==0) return SMBd18opddEnum;
-	      else if (strcmp(name,"SmbDesfac")==0) return SmbDesfacEnum;
+         else stage=10;
+   }
+   if(stage==10){
+	      if (strcmp(name,"SmbDesfac")==0) return SmbDesfacEnum;
 	      else if (strcmp(name,"SmbDpermil")==0) return SmbDpermilEnum;
 	      else if (strcmp(name,"SmbDzAdd")==0) return SmbDzAddEnum;
@@ -1121,9 +1135,8 @@
 	      else if (strcmp(name,"SMBhenning")==0) return SMBhenningEnum;
 	      else if (strcmp(name,"SmbMAdd")==0) return SmbMAddEnum;
-         else stage=10;
-   }
-   if(stage==10){
-	      if (strcmp(name,"SMBmeltcomponents")==0) return SMBmeltcomponentsEnum;
+	      else if (strcmp(name,"SMBmeltcomponents")==0) return SMBmeltcomponentsEnum;
 	      else if (strcmp(name,"SMBpdd")==0) return SMBpddEnum;
+	      else if (strcmp(name,"SMBpddSicopolis")==0) return SMBpddSicopolisEnum;
+	      else if (strcmp(name,"SMBgradientscomponents")==0) return SMBgradientscomponentsEnum;
 	      else if (strcmp(name,"SmbRlaps")==0) return SmbRlapsEnum;
 	      else if (strcmp(name,"SmbRlapslgm")==0) return SmbRlapslgmEnum;
Index: issm/trunk/src/c/shared/MemOps/MemOps.cpp
===================================================================
--- issm/trunk/src/c/shared/MemOps/MemOps.cpp	(revision 23389)
+++ issm/trunk/src/c/shared/MemOps/MemOps.cpp	(revision 23394)
@@ -16,5 +16,5 @@
 #if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)
 template <> adouble*  xNew(unsigned int size, const char* const contig) {
-	if (*contig == 't')
+	if (contig[0] == 't' || contig[0] == 'c')
 		ensureContiguousLocations(size);
 
Index: issm/trunk/src/c/shared/Numerics/extrema.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/extrema.cpp	(revision 23389)
+++ issm/trunk/src/c/shared/Numerics/extrema.cpp	(revision 23394)
@@ -11,16 +11,20 @@
 #include "./types.h"
 
+#ifndef _HAVE_CODIPACK_// already defined in codipack headers
 IssmDouble min(IssmDouble a,IssmDouble b){
 	if (a<b)return a;
 	else return b;
 }
+#endif
 int min(int a,int b){
 	if (a<b)return a;
 	else return b;
 }
+#ifndef _HAVE_CODIPACK_// already defined in codipack headers
 IssmDouble max(IssmDouble a,IssmDouble b){
 	if (a>b)return a;
 	else return b;
 }
+#endif
 int max(int a,int b){
 	if (a>b)return a;
@@ -28,5 +32,5 @@
 }
 
-#ifdef _HAVE_ADOLC_
+#ifdef _HAVE_AD_
 IssmPDouble  min(IssmPDouble a,IssmPDouble b){
 	if (a<b)return a;
Index: issm/trunk/src/c/shared/Numerics/isnan.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/isnan.cpp	(revision 23389)
+++ issm/trunk/src/c/shared/Numerics/isnan.cpp	(revision 23394)
@@ -13,9 +13,15 @@
   return std::isnan(X.getValue());
 }
-#endif
-
-#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)
 template <> int xIsInf<adouble> (const adouble& X){
   return std::isinf(X.getValue());
 }
 #endif
+
+#if defined(_HAVE_CODIPACK_) && !defined(_WRAPPERS_)
+template <> int xIsNan<IssmDouble> (const IssmDouble& X){
+	  return std::isnan(X.getValue());
+}
+template <> int xIsInf<IssmDouble> (const IssmDouble& X){
+	return std::isinf(X.getValue());
+}
+#endif
Index: issm/trunk/src/c/shared/Numerics/isnan.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/isnan.h	(revision 23389)
+++ issm/trunk/src/c/shared/Numerics/isnan.h	(revision 23394)
@@ -33,3 +33,9 @@
 #endif
 
+#if defined(_HAVE_CODIPACK_) && !defined(_WRAPPERS_)
+#include "./types.h"
+template <> int xIsNan<IssmDouble> (const IssmDouble& X);
+template <> int xIsInf<IssmDouble> (const IssmDouble& X);
 #endif
+
+#endif
Index: issm/trunk/src/c/shared/Numerics/numerics.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/numerics.h	(revision 23389)
+++ issm/trunk/src/c/shared/Numerics/numerics.h	(revision 23394)
@@ -20,8 +20,11 @@
 #include "./OptPars.h"
 
+#if !defined(_HAVE_CODIPACK_)
+// already defined in codipack headers
 IssmDouble  min(IssmDouble a,IssmDouble b);
 IssmDouble  max(IssmDouble a,IssmDouble b);
+#endif
 
-#ifdef _HAVE_ADOLC_
+#ifdef _HAVE_AD_
 IssmPDouble  min(IssmPDouble a,IssmPDouble b);
 IssmPDouble  max(IssmPDouble a,IssmPDouble b);
Index: issm/trunk/src/c/shared/Numerics/recast.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/recast.h	(revision 23389)
+++ issm/trunk/src/c/shared/Numerics/recast.h	(revision 23394)
@@ -15,5 +15,5 @@
 #endif
 
-#if !defined(_HAVE_ADOLC_) || defined(_WRAPPERS_)
+#if !defined(_HAVE_AD_) || defined(_WRAPPERS_)
 
 template<class To, class From> To reCast(const From& from) {
@@ -34,7 +34,14 @@
  * partial specialization
  */
+#ifdef _HAVE_ADOLC_
 template<class To> struct ForPartialSpecialization<To,adouble> {
     static  To reCast(const adouble& from ) { return (To) (from.getValue());}
 };
+#endif
+#ifdef _HAVE_CODIPACK_
+template<class To> struct ForPartialSpecialization<To,IssmDouble> {
+	    static  To reCast(const IssmDouble& from ) { return (To) (from.getValue());}
+};
+#endif
 
 #endif
Index: issm/trunk/src/c/shared/Numerics/types.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/types.h	(revision 23389)
+++ issm/trunk/src/c/shared/Numerics/types.h	(revision 23394)
@@ -22,13 +22,18 @@
 
 #if defined(_HAVE_ADOLC_) &&  !defined(_WRAPPERS_)
+/*ADOLC typedefs*/
 #include "adolc/adolc.h"
-// for active variables
-typedef adouble IssmDouble;
-// for passive variables
-typedef double IssmPDouble;
+typedef adouble IssmDouble; /*for active variables*/
+typedef double  IssmPDouble; /*for passive variables*/
+
+#elif defined(_HAVE_CODIPACK_) && !defined(_WRAPPERS_)
+/*CoDiPack typedefs*/
+#include <codi.hpp>
+typedef codi::RealReverse IssmDouble;
+typedef double            IssmPDouble;
+
+/*Non-AD typedefs*/
 #else 
-// see above
-typedef double IssmDouble; 
-// see above
+typedef double     IssmDouble; 
 typedef IssmDouble IssmPDouble;
 #endif
